Vue UI Components Documentation

Vue DropDownButton Component

The DropDownButton component for Vue will be able to display any type of content inside a DropDown.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The DropDownButton component for Vue requires the following import:


Add the jqxDropDownButton component to the components section of the the Vue class:


Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxDropDownButton/>

<template>
<JqxDropDownButton :width="width" :height="height">
<jqxTree :width="200">
<ul>
<li item-selected="true">Home</li>
<li item-expanded="true">
Solutions
<ul>
<li>Education</li>
<li>Financial services</li>
<li>Government</li>
<li>Manufacturing</li>
<li>
Solutions
<ul>
<li>eLearning</li>
<li>Mobile</li>
<li>RIA</li>
<li>Training</li>
</ul>
</li>
</ul>
</li>
<li>
Products
<ul>
<li>PC products</li>
<li>Mobile products</li>
<li>All products</li>
</ul>
</li>
</ul>
</jqxTree>
</JqxDropDownButton>
</template>

Properties

The properties of the <JqxDropDownButton/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 150,
height: 25
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxDropDownButton @open="onOpen()"
:width="width" :height="height">
<jqxTree :width="200">
<ul>
<li item-selected="true">Home</li>
<li item-expanded="true">
Solutions
<ul>
<li>Education</li>
<li>Financial services</li>
<li>Government</li>
<li>Manufacturing</li>
<li>
Solutions
<ul>
<li>eLearning</li>
<li>Mobile</li>
<li>RIA</li>
<li>Training</li>
</ul>
</li>
</ul>
</li>
<li>
Products
<ul>
<li>PC products</li>
<li>Mobile products</li>
<li>All products</li>
</ul>
</li>
</ul>
</jqxTree>
</JqxDropDownButton>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onOpen: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxDropDownButton ref="dropdownbutton"></JqxDropDownButton>

Here how you can use a component's method:

this.$refs.dropdownbutton.getContent();

methods: {
// Add here all used callbacks and/or events
onOpen: function () {
// Do something on change
let content = this.$refs.dropdownbutton.getContent();
alert(content);
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

DropDownButton Example

Run Code

Angular UI Components Documentation

Angular DropDownButton Component

The DropDownButton component for Angular will be able to display any type of content inside a DropDown.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxDropDownButton [theme]="'fluent'" #myDropDownButton style="float: left" 
    [width]="150" [height]="25">
    <jqxTree [theme]="'fluent'" #myTree 
        (onSelect)="treeOnSelect($event)" [width]="200">
        <ul>
            <li item-selected='true'>Home</li>
            <li item-expanded='true'>
                Solutions
                <ul>
                    <li>Education</li>
                    <li>Financial services</li>
                    <li>Government</li>
                    <li>Manufacturing</li>
                    <li>
                        Solutions
                        <ul>
                            <li>eLearning</li>
                            <li>Mobile</li>
                            <li>RIA</li>
                            <li>Training</li>
                        </ul>
                    </li>
                </ul>
            </li>
            <li>
                Products
                <ul>
                    <li>PC products</li>
                    <li>Mobile products</li>
                    <li>All products</li>
                </ul>
            </li>
        </ul>
    </jqxTree>
</jqxDropDownButton>

<div style="float: left; margin-top: 5px; margin-left: 30px">
    <jqxCheckBox [theme]="'fluent'" (onChange)="checkBoxOnChange($event)">
        Open On Mouse Over
    </jqxCheckBox>
</div>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, AfterViewInit, ViewEncapsulation } from '@angular/core';


import { jqxTreeModule, jqxTreeComponent } from 'jqwidgets-ng/jqxtree';
import { jqxDropDownButtonModule, jqxDropDownButtonComponent } from 'jqwidgets-ng/jqxdropdownbutton';

@Component({
    selector: 'app-root',
    imports: [jqxDropDownButtonModule, jqxTreeModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {
    @ViewChild('myDropDownButton') myDropDownButton: jqxDropDownButtonComponent;
    @ViewChild('myTree') myTree: jqxTreeComponent;

    ngAfterViewInit(): void {
        this.myDropDownButton.setContent('<div style="position: relative; margin-left: 3px; margin-top: 4px;">Home</div>');
    }

    treeOnSelect(event: any): void {
        let item = this.myTree.getItem(event.args.element);
        let dropDownContent = `<div style="position: relative; margin-left: 3px; margin-top: 4px;">${item.label}</div>`;
        this.myDropDownButton.setContent(dropDownContent);
    }

    checkBoxOnChange(event: any): void {
        this.myDropDownButton.autoOpen(event.args.checked);
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

DropDownButton API

API Reference of the jQWidgets DropDownButton component for Angular: DropDownButton API

React UI Components Documentation

Typescript React DropDownButton Component

This tutorial will show you the basics of how to get started with the jQWidgets DropDownButton React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxDropDownButton, { IDropDownButtonProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxdropdownbutton';

II. Class:

class App extends React.PureComponent<{}, IDropDownButtonProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxDropDownButton
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

ReactDOM.render(<App />, document.getElementById('app'));

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

class App extends React.PureComponent<{}, IDropDownButtonProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxDropDownButton onNameOfEvent={this.handleEvent}
width={this.state.width} height={"100%"} .....
/>
)
}
private handleEvent(e: Event): void {
// Do Something ...
}
}

Methods & Properties

This is how you call methods & props:

//Get Methods
const value = this.myDropDownButton.current!.methodName(arg1, arg2);
//Set Methods
this.myDropDownButton.current!.methodName(arg1, arg2);
//Get Properties
const height = this.state.height;
//Set Properties
this.setState({ height: 250 });

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

this.myDropDownButton.current!.setOptions({ width: 350, height: 400 });

Every component also have a method getOptions which returns the value of the requested option.

const width = this.myDropDownButton.current!.getOptions('width');

DropDownButton API

API Reference of the jQWidgets DropDownButton React Component: DropDownButton API

DropDownButton Demos

Demos Reference of the jQwidgets DropDownButton React Component: DropDownButton Demos